from typing import Optional
from pydantic import BaseModel
from OSMPythonTools.api import Api
from .landmarktype import LandmarkType
from .preferences import Preferences

class LandmarkTest(BaseModel) :
    name : str
    attractiveness : int
    loc : tuple

# Output to frontend
class Landmark(BaseModel) :
    name : str
    type: LandmarkType      # De facto mapping depending on how the query was executed with overpass. Should still EXACTLY correspond to the preferences
    location : tuple
    osm_type : str
    osm_id : int
    attractiveness : int
    must_do : bool
    n_tags : int
    time_to_reach : Optional[int] = 0


